/**
 * 
 */
var mX=0,mY=0;

var outputMsgs=[];
var canvas;
var cntx;

var tapping=false;

function initialise(){
	simulating=false;
	
	showAppTitle();
	showButtonCaptions();
	showProblem();
	adjustCode();
	placeContents();
	$("#drawArea").hide();
	showSimulationValues(); //καλείται για να αποκρύψει όλα τα span elements
	initialiseGraphics();
	initialiseEvents();
	showPrompt();
	setParameterValue(0,100);
}

function initialiseEvents(){
    
    $(".toChange").focus(function(){
        if(simulating){
            $("#"+this.id).blur();
        }
    });
    
    //Χρωματική αντιστοιχία ελεύθερου κειμένου και ψευδογλώσσας
    $(".algoStep").hover(
        function(){
            if(enableRepresentationMatching){
                var index=parseInt(this.id.substr(4,1));
                $("#"+this.id).addClass("matched");
                showMatches(index);
            }
        },
        function(){
            $(".matched").removeClass("matched");
        }
    );
    
    
    $(".algoStep").on("tap",function(){
        $(".matched").removeClass("matched");
        if(enableRepresentationMatching){
            var index=parseInt(this.id.substr(4,1));
            $("#"+this.id).addClass("matched");
            showMatches(index);
        }        
    });
    
    document.addEventListener("touchend",function(evt){
        if(tapping){
            tapping=false;
            $(".matched").removeClass("matched");
            evt.preventDefault();
            return;
        }
    });
    
	$("#clearBreakPoints").on("click touchend",function(){
	    $(".breakPointCmd").removeClass("breakPointCmd");
	});
	
	$("#visualisation").on("mousemove touchend",function(evt){
		var rect = canvas.getBoundingClientRect();
		mX=evt.clientX-rect.left;
	    mY=evt.clientY-rect.top;
		handleMouseMove();
	});
	
	$(".algoCmd").on("click touchend",function(evt){
	    if(evt.target.id.substr(0,7)=="usrEntr") return;
		if($("#"+this.id).hasClass("breakPointCmd")){
			$("#"+this.id).removeClass("breakPointCmd");
		}
		else{
			$("#"+this.id).addClass("breakPointCmd");
		}
	});

	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	//Κουμπιά διαχείρισης καταχωρήσεων εξόδου
	$("#btnFirst").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-firstVisibleCell);
	});

	$("#btnPrevious").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(-1);
	});

	$("#btnNext").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(1);
	});

	$("#btnLast").on("click touchstart",function(evt){
		evt.preventDefault();
		handleArray(outputMsgs.length-1-firstVisibleCell);
	});

	//Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
	
    $("#showCaptions").bind("change keyup touchend",function(event,ui) {
    	if($("#showCaptions:checked").val()=="show"){
    		buttonCaptionsVisible=true;
    	}
    	else{
    		buttonCaptionsVisible=false;
    	}
    	showButtonCaptions();
    });
    
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
    	if($("#showVarValues:checked").val()=="show"){
    		showVarValues=true;
    	}
    	else{
    		showVarValues=false;
    	}
    });
    
    $("#showComments").bind("change keyup touchend",function(event,ui) {
    	if($("#showComments:checked").val()=="show"){
    		$("#commentArea").slideDown("slow");
    		showComments=true;
    	}
    	else{
    		$("#commentArea").slideUp("slow");
    		showComments=false;
    	}
    });
	
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
    	if($("#requestConfirmations:checked").val()=="reqConfirm"){
    		requestConfirmationState=requestConfirmation;
    	}
    	else{
    		requestConfirmationState=dontRequestConfirmation;
    	}
    });
    
    $("#matchRepresentations").bind("change keyup touchend",function(event,ui) {
        if($("#matchRepresentations:checked").val()=="reqRepresentations"){
            enableRepresentationMatching=true;
        }
        else{
            enableRepresentationMatching=false;
        }
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
    	if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
    		hideSimulationPath=false;
    	}
    	else{
    		hideSimulationPath=true;
    	}
    });

    $("#btnPlay").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnPlay").hide();
    	$("#btnStop").show();
    	$("#btnPause").prop("disabled",false);
    	$("#btnForward").prop("disabled",true);
		//resetSimulation(); //Η εντολή απενεργοποιείται για να είναι δυνατή η αυτόματη εκτέλεση από εκεί που σταμάτησε η βηματική
    	promptID=promptDuringRunning;
    	simulationAborted=false;
    	simulateCode(true);
    });
    
    $("#btnStop").on("click touchstart",function(){
        $("#drawArea").hide(animationRate);
    	simulating=false;
    	simulateCode(false);
    	resetSimulation();
    	$("#btnPlay").show();
    	$("#btnStop").hide();
    	$("#btnPause").show();
    	$("#btnContinue").hide();
    	$("#btnForward").show();
    	if(simulationAborted){
    	    promptID=promptToFillInBlanks;
    	}
    	else{
    	    promptID=promptToRunCode;
    	}
    	showPrompt();
    });
    
    $("#btnPause").on("click touchstart",function(){
    	$("#showOptions").show();
    	simulating=false;
    	$("#btnPause").hide();
    	$("#btnContinue").show();
    	clearInterval(timerLoop);
    	handleContinuationButtons();
    	showPrompt();
    });
    
    $("#btnContinue").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnContinue").hide();
    	$("#btnForward").prop("disabled",true);
    	$("#btnPause").show();
    	simulateCode(true);
    });
                
    $("#btnForward").on("click touchstart",function(){
        $("#drawArea").show(animationRate);
        simulationAborted=false;
    	if(simulationIndex==-1){
    		resetSimulation();
    	}
    	if(simulationIndex<=parseInt(outputSum.substr(3,2))){ /**@@@@@@***************/
    		simulateRun();
    	}
    });
    
    $("#btnCheckCode").on("click touchstart",function(){
    	checkCode();
    	handleContinuationButtons();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	showSolution();
    });

    $("#btnShowHint").on("click touchstart",function(){
        showNextHint();
    });
    
    $("#btnInitialiseCode").on("click touchstart",function(){
    	if(requestConfirmationState || confirm("ΠΡΟΣΟΧΗ! Η εντολή αυτή θα επαναφέρει τις αρχικές καταχωρήσεις και θα διαγράψει όλα τα Σημεία Διακοπής. Είσαι σίγουρος;")){
        	$(".breakPointCmd").removeClass("breakPointCmd");
        	$(".hintedCommand").removeClass("hintedCommand");
            $("#drawArea").hide(animationRate);
            selectedHint=-1;
        	simulating=false;
            simulateCode(false);
        	resetSimulation();
        	handleContinuationButtons();
        	showUserEntries();
        	countEntries();
    	}
    });

    $("#btnEnter").on("click touchstart",function(){
		if(simulating)timerLoop=setInterval(function(){simulateRun();},simSpeed);
    });
    
    $(".cellNavigation").mouseover(function(){
    	if($(this).css("opacity")>0){
      	  $("#"+this.id).fadeTo(0,1);
    	  $("#"+this.id).css({
    		  "background-color" : "#c0c0c0",
    		  "box-shadow" : "1px 1px 2px #000000,2px 2px 4px #505050,3px 3px 6px #a0a0a0"
    	  });
    	}
    });
    
    $(".cellNavigation").mouseout(function(){
    	if($(this).css("opacity")>0){
        	$(this).fadeTo(0,0.5);
        	$(this).css({
        		"background-color" : "#ffffff",
        		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
        	});
    	}
    });
}

function setParameterValue(paramIndex,newValue){
	$("#number-"+String.fromCharCode(65+paramIndex)).val(newValue);
	varValues[paramIndex]=newValue;
	if(paramIndex==0){
	    hSimInit=newValue;
	}
}

function handleMouseDown(){
}

function handleMouseUp(){
}

function handleMouseMove(){
	if(debugMode) document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" promptID="+promptID+" , "+slctdNo;
}

function handleMouseOut(){
}

function placeContents(){
	codeTopBorder=$("#buttonArea").outerHeight();
	drawTopBorder=codeTopBorder+$("#problemWording").outerHeight()+verticalBorder;
	commentTopBorder=codeTopBorder+$("#algorithmStart").outerHeight()+1.5*verticalBorder;
	
	$("#problemWording").css({left: horizontalBorder, top: codeTopBorder});
    codeLeftBorder=$("#problemWording").outerWidth()+2*horizontalBorder;

	$("#algorithmStart").css({left: codeLeftBorder, top: codeTopBorder});
	$("#commentArea").css({left: codeLeftBorder, top: commentTopBorder, width: $("#algorithmStart").width(), height: 40});
	$("#drawArea").css({top: drawTopBorder});
	//"Πάνω" κουμπιά
	$("#btnFirst").css({left: -$("#btnFirst").width(), top: 0});
    $("#btnPrevious").css({left: -$("#btnFirst").width(), top: $("#btnFirst").outerHeight()});
    //"Κάτω" κουμπιά
    $("#btnLast").css({left: -$("#btnFirst").width(), top: $("#visualisation").position().top+$("#visualisation").outerHeight()-$("#btnLast").outerHeight()});
    $("#btnNext").css({left: -$("#btnFirst").width(), top: $("#btnLast").position().top-$("#btnNext").outerHeight()});
    //Επιφάνεια σχεδίασης
    $("#visualisation").css({left: $("#btnLast").position().left+$("#btnLast").outerWidth()+horizontalBorder, top: 0});
    $("#drawArea").height($("#visualisation").height+2*verticalBorder);
    //περιοχή ειδοποιήσεων
    promptTopBorder=verticalBorder+drawTopBorder+$("#visualisation").outerHeight();
    $("#promptArea").css({top: promptTopBorder});
}

function adjustCode(){
	var j=-1;
	var html="<code class='algorithm'>";
	j++;
	html+="\n<span class='algoCmd' id='cmd0'>s <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='sumInitVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd1'>σ <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='adderInitVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd2'><span class='reservedWord'>ΓΙΑ</span> i <span class='reservedWord'>ΑΠΟ</span> "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" <span class='reservedWord'>ΜΕΧΡΙ</span> "+generateEntryPlaceholder("usrEntr"+(j+1),userEntries[j+1],editableState)+"</span>   <span class='showValues' id='fromToVal'></span>";
    j+=2;
    html+="\n<span class='algoCmd' id='cmd3'>  s <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='sumVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd4'>  σ <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='adderVal'></span>";
    html+="\n<span class='algoCmd' id='cmd5'><span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>   <span class='showValues' id='iVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd6'>s <- "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+"</span>   <span class='showValues' id='quotientVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd7'><span class='reservedWord'>ΓΡΑΨΕ</span> \"Θα πρέπει να δοθούν \" , "+generateEntryPlaceholder("usrEntr"+j,userEntries[j],editableState)+" , \" τόνοι.\"</span>   <span class='showValues' id='sumToPrint'></span>";
    html+="</code>";
	$("#algorithmStart").html(html);

	//Προσθήκη event παρακολούθησης εισόδου χρήστη σε κάθε editable τμήμα
    for(var i=0;i<noOfEntries;i++){
    	if(document.getElementById("usrEntr"+i)){
            document.getElementById("usrEntr"+i).addEventListener("input", function() {
        	    saveUserEntry(this.id);
        	}, false);
    	}
    }    	
}

function showProblem(){
	$("#problemWording").css({left: 0, top: codeTopBorder});
	$("#problemWording").html(getProblemWording());
}

function getProblemWording(){
    var html="Λέγεται πως όταν πρωτοπαρουσίασαν το σκάκι σε έναν βασιλιά, αυτός ενθουσιάστηκε τόσο με αυτό, ώστε έταξε στον εμπνευστή του ότι θα του έδινε οποιαδήποτε αμοιβή ζητούσε. ";
    html+="Αυτός ζήτησε <i>απλώς</i> να του δώσουν ένα σπόρο σιταριού για το πρώτο τετράγωνο, δύο σπόρους για το δεύτερο, τέσσερεις για το τρίτο και, γενικά, διπλασιασμό της ποσότητας για κάθε επόμενο τετράγωνο της σκακιέρας μέχρι το 64ο. ";
    html+="Χωρίς πολλή σκέψη, ο βασιλιάς δέχτηκε αμέσως. Αντιλήφθηκε το σφάλμα του μόνο όταν ο θησαυροφύλακας έκανε τους υπολογισμούς σε σπόρους και μετέτρεψε την ποσότητα σε τόνους (θεωρώντας ότι ένα κιλό σταριού αποτελείται περίπου από 20.000 σπόρους). ";
    html+="Θέλουμε να γράψουμε τις εντολές που θα καθοδηγήσουν τον υπολογιστή να υπολογίσει την ποσότητα αυτή.";
    html+="<br>Τα βήματα του αλγόριθμου έχουν ως εξής:";
    html+="<p class='algoStep' id='step1'><b>1.</b> Αρχικοποιούμε τη μεταβλητή <span class='suggestedName'>s</span> που θα παίξει το ρόλο του Αθροιστή.</p>";
    html+="<p class='algoStep' id='step2'><b>2.</b> Αρχικοποιούμε το πλήθος <span class='suggestedName'>σ</span> των σπόρων.</p>";
    html+="<p class='algoStep' id='step3'><b>3.</b> Δημιουργούμε μια δομή επανάληψης για τη σάρωση όλων των τετραγώνων μιας σκακιέρας.</p>";
    html+="<p class='algoStep' id='step4'><b>4.</b> Σε κάθε επανάληψη προσθέτουμε το τρέχον πλήθος σπόρων στο σύνολο.</p>";
    html+="<p class='algoStep' id='step5'><b>5.</b> Υπολογίζουμε το πλήθος σπόρων που θα τοποθετηθούν στο επόμενο τετράγωνο.</p>";
    html+="<p class='algoStep' id='step6'><b>6.</b> Μετά την ολοκλήρωση του υπολογισμού μετατρέπουμε την ποσότητα σε τόνους.</p>";
    html+="<p class='algoStep' id='step7'><b>7.</b> Εμφανίζουμε το τελικό αποτέλεσμα.</p>";
	html+="Προσπάθησε να συμπληρώσεις τις εντολές που υλοποιούν τον αλγόριθμο αυτό.";
	return html;
}

function showButtonCaptions(){
	if(buttonCaptionsVisible){
        $("#btnCheckCode").html("Υποβολή");
        $("#btnShowSolution").html("Λύση");
        $("#btnShowHint").html("Βοήθεια");
        $("#btnInitialiseCode").html("Επαναφορά");
        $("#btnPlay").html("Έναρξη");
        $("#btnStop").html("Αρχικοποίηση");
        $("#btnPause").html("Παύση");
        $("#btnContinue").html("Συνέχεια");
        $("#btnForward").html("Επόμενο");
        $("#btnOptions").html("Ρυθμίσεις");
        $(".btnMenu").css({"width":"175px"});
        $(".buttonData").width(160);
 	}
	else{
        $("#btnCheckCode").html("");
        $("#btnShowSolution").html("");
        $("#btnShowHint").html("");
        $("#btnInitialiseCode").html("");
        $("#btnPlay").html("");
        $("#btnStop").html("");
        $("#btnPause").html("");
        $("#btnContinue").html("");
        $("#btnForward").html("");
        $("#btnOptions").html("");
        $(".btnMenu").css({"width":"30px"});
        $(".buttonData").width(40);
    }
	placeContents();
}

function showPrompt(){
	var msg="";
	if(selectedHint==-1){//Δείξε βασικά prompts
	    switch(promptID){
	        case promptToFillInBlanks:
	            msg="Προσπάθησε να λύσεις το πρόβλημα, συμπληρώνοντας ορθά τα κενά των εντολών που βλέπεις.";
	            msg+="<br>Αν δυσκολεύεσαι, ίσως σε βοηθήσει η προβολή αντιστοιχίας μεταξύ του <i>Ελεύθερου Κειμένου</i> και της <i>Ψευδογλώσσας</i> μέσω των Ρυθμίσεων.";
	            msg+="<br>Μπορείς να ελέγξεις την άποψή σου με το κουμπί [Υποβολή], ή να ";
	            if($("#btnShowHint").is(":visible")){
	                msg+="πάρεις υποδείξεις για τη λύση με το κουμπί [Βοήθεια].";	                
	            }
	            else{
                    msg+="δεις την ορθή εκδοχή του προγράμματος με το κουμπί [Λύση]";                 
	            }
	            break;
	        case promptToRunCode:
	            msg="Αν θεωρείς τη λύση ολοκληρωμένη, 'τρέξε' το πρόγραμμά σου με το κουμπί [Έναρξη].";
	            msg+=" Επιλέγοντας μία εντολή, μπορείς να προσθέσεις Σημείο Διακοπής (Breakpoint).";
	            msg+="<br>Εναλλακτικά, δοκίμασε τη βηματική εκτέλεση με το κουμπί [Επόμενο].";
	            msg+="<br>Χρησιμοποίησε τις Ρυθμίσεις Προσομοίωσης για να προβάλλεις πρόσθετες πληροφορίες υπό μορφή επεξηγήσεων.";
	            break;
	        case promptDuringRunning:
	            if($("#btnContinue").is(":visible")){
	                msg="Χρησιμοποίησε το κουμπί [Επόμενο] για να εκτελεστεί η επόμενη εντολή.";
	                msg+="<br>Χρησιμοποίησε το κουμπί [Συνέχεια] για να επιστρέψεις στην αυτόματη εκτέλεση.";
	            }
	            else{
	                msg="Χρησιμοποίησε το κουμπί [Παύση] για να διακόψεις την αυτόματη εκτέλεση.";
	            }
	            msg+="<br>Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να τερματίσεις την αυτόματη εκτέλεση.";
	            break;
	        case promptAtEndOfRun:
	            msg="Χρησιμοποίησε το κουμπί [Αρχικοποίηση] για να διαγράψεις τα αποτελέσματα της εκτέλεσης του προγράμματος.";
	            break;
	        case promptSubmittedSolution:
	            if(errorsFound){
	                msg="Η εκδοχή που προτείνεις δεν είναι σωστή.";
	                msg+="<br>Μελέτησε προσεκτικότερα την εκφώνηση του προβλήματος, προσπαθώντας να βρεις τις αντιστοιχίες των φράσεων του <i>Ελεύθερου Κειμένου</i> με τις εντολές της <i>Ψευδογλώσσας</i>.";
	                msg+="<br>Μπορείς να κάνεις ορατές τις αντιστοιχείς αυτές μέσω των Ρυθμίσεων.";
	            }
	            else{
	                if(solutionType==userSolution){
	                    msg="Πράγματι βρήκες μία λύση του προβλήματος.";
	                }
	                else{
	                    msg="Αυτή που βλέπεις είναι μία λύση του προβλήματος.";
	                }
	                msg+="<br>'Τρέξε' τώρα το πρόγραμμα για να υπολογίσεις την ποσότητα σπόρων.";
	            }
	            break;
	    }	    
	}
	else{//Δείξε hint-prompts
        var selectedCommand=-1;
	    switch(selectedHint){

            case 0:
                selectedCommand=0;
                msg="ΓΡΑΜΜΗ 1: Όλοι οι αθροιστές αρχικοποιούνται με την ίδια τιμή.";
                break;
            case 1:
                selectedCommand=1;
                msg="ΓΡΑΜΜΗ 2: Αφού η πρώτη εντολή μέσα στη Δομή Επανάληψης είναι η ενημέρωση του αθροιστή, πρέπει η σ να είναι έτοιμη για την πρώτη πρόσθεση.";
                break;
            case 2:
                selectedCommand=2;
                msg="ΓΡΑΜΜΗ 3: Η Δομή Επανάληψης χρησιμοποιείται για να σαρώσουμε τη σκακιέρα ξεκινώντας από το αρχικό τετράγωνο.";
                break;
            case 3:
                selectedCommand=2;
                msg="ΓΡΑΜΜΗ 3:  Η Δομή Επανάληψης χρησιμοποιείται για να σαρώσουμε τη σκακιέρα φτάνοντας μέχρι το τελευταίο τετράγωνο.";
                break;
            case 4:
                selectedCommand=3;
                msg="ΓΡΑΜΜΗ 4: Σε κάθε επανάληψη η τιμή του αθροιστή πρέπει να ενημερώνεται με το τρέχον πλήθος σπόρων.";
                break;
            case 5:
                selectedCommand=4;
                msg="ΓΡΑΜΜΗ 5: Η μεταβλητή σ πρέπει να ετοιμαστεί για την επόμενη επανάληψη.";
                break;
            case 6:
                selectedCommand=6;
                msg="ΓΡΑΜΜΗ 7: Το αποτέλεσμα πρέπει να μετατραπεί σε τόνους.";
                break;
            case 7:
                selectedCommand=7;
                msg="ΓΡΑΜΜΗ 8: Πρέπει να εμφανιστεί το περιεχόμενο της μεταβλητής όπου έχει αποθηκευτεί το τελικό αποτέλεσμα.";
                break;	        
            case hintShown.length:
                msg="Φαίνεται ότι συμπληρώθηκαν όλα τα κενά των εντολών. Δοκίμασε να εκτελέσεις τον αλγόριθμό σου για να ελέγξεις την ορθότητά του.";
                selectedHint=-1;
                break;
	    }
	    $("#cmd"+selectedCommand).addClass("hintedCommand");
	}

    $("#prompt").html(msg);
}

function showNextHint(){
    var hintsCounter=0;
    if(selectedHint==-1){//Έχει ολοκληρωθεί η διαχείριση του προηγουμενου hint
        $(".hintedCommand").removeClass("hintedCommand");
        for(var i=0;i<hintShown.length;i++){//Καταμέτρηση ολοκληρωμένων hints
            var currentEntry=userEntries[i]===undefined?"":trimSpaces(userEntries[i]);
            if(Array.isArray(officialEntries[i])){
                var found=false;
                var j=0;
                while(j<officialEntries[i].length && !found){
                    found=currentEntry==trimSpaces(officialEntries[i][j]);
                    j++;
                }
                hintShown[i]=found;
            }
            else{
                hintShown[i]=currentEntry==trimSpaces(officialEntries[i]);
            }
            if(hintShown[i]){
                hintsCounter++;
            }
        }
        if(hintsCounter==hintShown.length){//Αν όλες οι καταχωρήσεις είναι ορθές...
            $("#btnShowHint").hide();
            $("#btnShowSolution").show();
            selectedHint=hintShown.length;
            showPrompt();//...εμφάνισε σχετικό μήνυμα
        }
        else{//αλλιώς έλεγξε αν έχει ήδη επιλεγεί επόμενο hint προς προβολή
            do{//... διάλεξε ένα στην τύχη
                selectedHint=parseInt(Math.random()*hintShown.length);
            }while(hintShown[selectedHint]);
            showPrompt();//δείξε το επιλεγμένο hint
        }
    }
    else{//Δεν έχει ολοκληρωθεί η διαχείριση του προηγουμενου hint
        if(Array.isArray(officialEntries[selectedHint])){
            var variationIndex=parseInt(Math.random()*officialEntries[selectedHint].length);
            userEntries[selectedHint]=officialEntries[selectedHint][variationIndex];
        }
        else{
            userEntries[selectedHint]=officialEntries[selectedHint];
        }
        showUserEntries();
        selectedHint=-1;
    }
}

function showUserEntries(){
    var code;
    for(var i=0;i<noOfEntries;i++){
        code="ˍˍˍ";
        if(userEntries[i]!=null && userEntries[i]!=""){
            code=userEntries[i];
        }
        $("#usrEntr"+i).html(code);
    }
}

function showSolution(){
    var selectedPart="";
	if(requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
		for(var i=0;i<noOfEntries;i++){
            if(Array.isArray(officialEntries[i])){
                var j=parseInt(Math.random()*officialEntries[i].length);
                selectedPart=officialEntries[i][j];
            }
            else{
                selectedPart=officialEntries[i];
            }
		    $("#usrEntr"+i).html(selectedPart);		    
		}
		solutionType=officialSolution;
		promptID=promptSubmittedSolution;
		showPrompt();
	}
}

function checkCode(){
	var solutionOK=true;
	var j=0;
	var submitted;
	var official;
	var loopBeginVal=0;
	var loopEndVal=0;
	while(j<noOfEntries && solutionOK){
		if(j==2){//Όρια δομής επανάληψης
			loopBeginVal=parseFloat(stringExpressionValue(document.getElementById("usrEntr2").textContent.toLowerCase(),varNames,varValues,"","",false));
			loopEndVal=parseFloat(stringExpressionValue(document.getElementById("usrEntr3").textContent.toLowerCase(),varNames,varValues,"","",false));
			var loopRepetitions=loopEndVal-loopBeginVal+1;
			if(loopRepetitions!=officialRepetitions)solutionOK=false;
			j+=2;
		}
		else{
			submitted=trimSpaces(document.getElementById("usrEntr"+j).textContent.toLowerCase());
			if(Array.isArray(officialEntries[j])){
			    if(j==5 && loopBeginVal!=1 && submitted.indexOf("^")>-1){//υπολογισμος πλήθους σπόρων με σχέση της μορφής 2^i
					var offset="0";
					if(loopBeginVal>1){
						offset="-"+(loopBeginVal-1);
					}
					else{
						offset="+"+(1-loopBeginVal);
					}
					if(submitted!="2^(i"+offset+")")solutionOK=false;
				}
				else{
				    solutionOK=checkAgainstArray(submitted,j);
				}
			}
			else{
			    official=trimSpaces(officialEntries[j].toLowerCase());
		        if(submitted!=official)solutionOK=false;
			}
			j++;
		}
	}
	if(solutionOK){
		errorsFound=false;
		if(debugMode)alert("Πολύ σωστά!");
	}
	else{
		errorsFound=true;
		if(debugMode)alert("Υπάρχουν λάθη...");
	}
	promptID=promptSubmittedSolution;
	showPrompt();
	enableCodeSimulation();
}

function checkAgainstArray(submitted,j){
    var result=false;
    var official="";
    var i=0;
    while(!result && i<officialEntries[j].length){
        official=trimSpaces(officialEntries[j][i].toLowerCase());
        result=result || (submitted==official);
        i++;
    }
    return result;
}

function enableCodeSimulation(){
	$("#simulateControls").show(animationRate);
	$("#dataInput").show(animationRate);
}

function simulateCode(simulationSwitch){
	if(simulationSwitch){
	    $("#drawArea").show(animationRate);
	    mSimLimit=mSimLimitMin()+parseInt(Math.random()*10);
		//έναρξη προσομοίωσης με κλήση timer
		timerLoop=setInterval(function(){simulateRun();},simSpeed);
	}
	else{
		clearInterval(timerLoop);
		simulating=false;
		$("#btnContinue").hide();
		$("#btnForward").hide();
    	$("#btnPlay").hide();
    	$("#btnPause").prop("disabled",true);
    	$("#btnStop").show();
    	$("#showOptions").show();
	}	
}

function simulateRun(){
	var entryResult;
	var jStart=0;
	simulationIndex++;
	var nxtSimulationIndex=simulationIndex;
	var cmdSimulated="cmd"+simulationIndex;
	if(showComments) showCurrentComment(cmdSimulated);
	if($("#"+cmdSimulated).hasClass("breakPointCmd")){
		$("#btnPause").click();//Παύση σε breakpoint
	}
	handleContinuationButtons();
	
	$(".simulatingCode").removeClass("simulatingCode");
	if(hideSimulationPath){
		jStart=simulationIndex;
	}
	//εμφάνιση μονοπατιού προσομοίωσης
	for(var j=jStart;j<=simulationIndex;j++){
		$("#cmd"+j).addClass("simulatingCode");
	}
	
	//Προσομοίωση αλγόριθμου
	switch(cmdSimulated){
        case init1:
            entryResult=stringExpressionValue($("#usrEntr0").text(),varNames,varValues,[],[]);
            if(entryResult=="error"){
                abortSimulation();
                return;
            }
            else{
                sumSim=entryResult;
                varValues[0]=sumSim;
            }
            break;
	    case init2:
	        entryResult=stringExpressionValue($("#usrEntr1").text(),varNames,varValues,[],[]);
	        if(entryResult=="error"){
	            abortSimulation();
	            return;
	        }
	        else{
	            adderSim=entryResult;
	            varValues[1]=adderSim;
	        }
	        break;
        case LoopStart:
            entryResult=stringExpressionValue($("#usrEntr2").text(),varNames,varValues,[],[]);
            var entryResult2=stringExpressionValue($("#usrEntr3").text(),varNames,varValues,[],[]);
            if(entryResult=="error" || entryResult2=="error"){
                abortSimulation();
                return;
            }
            else{
                fromSim=entryResult;
                toSim=entryResult2;
                if(!loopStarted){
                    iSim=fromSim;
                    loopStarted=true;
                }
                else{
                    if(parseInt(iSim)>parseInt(toSim)){
                        nxtSimulationIndex=parseInt(LoopEnd.substr(3,2));
                    }
                }
                varValues[2]=iSim;
            }
            break;
	    case updateSum:
            entryResult=stringExpressionValue($("#usrEntr4").text(),varNames,varValues,[],[]);
            if(entryResult=="error"){
                abortSimulation();
                return;
            }
            else{
                sumSim=entryResult;
                varValues[0]=sumSim;
            }
	        break;
        case updateAdder:
            entryResult=stringExpressionValue($("#usrEntr5").text(),varNames,varValues,[],[]);
            if(entryResult=="error"){
                abortSimulation();
                return;
            }
            else{
                adderSim=entryResult;
                varValues[1]=adderSim;
            }
            break;
        case LoopEnd:
            firstRepetitionComplete=true;
            iSim++;
            nxtSimulationIndex=parseInt(init2.substr(3,2));
            break;
        case convertSum:
            firstRepetitionComplete=false;
            entryResult=stringExpressionValue($("#usrEntr6").text(),varNames,varValues,[],[]);
            if(entryResult=="error"){
                abortSimulation();
                return;
            }
            else{
                sumSim=entryResult;
                varValues[0]=sumSim;
            }
            break;
        case outputSum:
            entryResult=stringExpressionValue($("#usrEntr7").text(),varNames,varValues,[],[]);
            if(entryResult=="error"){
                abortSimulation();
                return;
            }
            else{
                sumSim=entryResult;
                varValues[0]=sumSim;
                outputMsgs.push("Θα πρέπει να δοθούν "+(sumSim).formatNumber(3, ',', '.')+" τόνοι.");
                makeVisible(outputMsgs.length,forceArrayDraw);
                drawArray(firstVisibleCell);
            }
            break;
	}
	showSimulationValues();
	if(simulationIndex>parseInt(outputSum.substr(3,2))){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
		simulateCode(false);
		promptID=promptAtEndOfRun;
	}
	simulationIndex=nxtSimulationIndex;
	showPrompt();
}

function showCurrentComment(cmdSimulated){
	var comment="";
	switch(cmdSimulated){
	case init1:
	    comment="Αρχικοποίηση αθροιστή.";
	    break;
	case init2:
		comment="Καθορισμός πλήθους σπόρων που θα τοποθετηθούν στο πρώτο τετράγωνο της σκακιέρας.";
	    break;
	case LoopStart:
	    comment="Όρια Δομής Επανάληψης για τη σάρωση όλων των θέσεων της σκακιέρας.";
        break;
	case updateSum:
		comment="Ενημέρωση αθροιστή με το πλήθος σπόρων του τρέχοντος τετραγώνου.";
		break;
	case updateAdder:
		comment="Υπολογισμός σπόρων για το επόμενο τετράγωνο της σκακιέρας.";
		break;
    case LoopEnd:
        comment="Επόμενη τιμή του μετρητή της Δομής Επανάληψης";
        break;
    case convertSum:
        comment="Μετατροπή του συνολικού πλήθους των σπόρων σε τόνους.";
        break;
	case outputSum:
		comment="Εμφάνιση του τελικού αποτελέσματος.";
		break;
	}
	$("#commentArea").html(comment);
}

function makeVisible(cellIndex,forceDrawFlag){
	var arrayNotDrawn=true;
	while(cellTop(cellIndex,firstVisibleCell)>canvas.height-cellSize){
		firstVisibleCell++;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	while(cellTop(cellIndex,firstVisibleCell)<0){
		firstVisibleCell--;
		drawArray(firstVisibleCell);
		arrayNotDrawn=false;
	}
	if(forceDrawFlag && arrayNotDrawn) drawArray(firstVisibleCell);
	handleNavigationButtons();
}

function handleContinuationButtons(){
	if(simulating)return;
	if(simulationIndex>parseInt(outputSum.substr(3,2))){
		$("#btnForward").prop("disabled",true);
	}
	else{
		$("#btnForward").prop("disabled",false);
	}
}

function clearSimulated(){
	$(".simulatingCode").removeClass("simulatingCode");
	$(".conditionTrue").removeClass("conditionTrue");
	$(".conditionFalse").removeClass("conditionFalse");
	$(".conditionInError").removeClass("conditionInError");
}

function resetSimulation(){
	initialiseArray();
	resetErrorMessages();
	clearSimulated();
	simulationIndex=-1;
	handleContinuationButtons();
	showSimulationValues();
	$("#commentArea").html("");
}

function generateEntryPlaceholder(entryID,presetValue,editableState){
	var content="ˍˍˍ";
	var classToShow=(editableState)?"class='toChange'":"";
	if(presetValue!== undefined)content=presetValue;
	var newEntry="<span "+classToShow+" id='"+entryID+"' contenteditable='true'>"+content+"</span>";
	return newEntry;
}

function initialiseGraphics(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    //Πλάτος καμβά ίσο με το διαθέσιμο πλάτος προβολής
    //cntx.canvas.width=window.innerWidth;
    initialiseArray();
}

function initialiseArray(){
    loopStarted=false;
    firstRepetitionComplete=false;
    outputMsgs=[];
	handleArray(0);
}

function drawArray(startingCell){
	cntx.clearRect(0,0,canvas.width,canvas.height);
	var i;
	for(i=0;i<outputMsgs.length;i++){
		drawCell(i,startingCell);
	}
}

function drawCell(i,startingCell){
	var topCoord=cellTop(i,startingCell);
	//Μη σχεδιάζεις κελιά εκτός ορατών ορίων
	if(topCoord<0 || topCoord>canvas.height) return;
	
    var content=outputMsgs[i]+"";
    cntx.font="18px Georgia";
    var contentLeft=horizontalBorder;
    cntx.fillText(content,contentLeft,topCoord+cellSize-(cellSize-20)/2);
}

function cellTop(i,startingCell){
	return (i-startingCell)*cellSize;
}

function handleArray(step){
	firstVisibleCell+=step;
	handleNavigationButtons();
	drawArray(firstVisibleCell);
}

function handleNavigationButtons(){
	if(outputMsgs.length==0){
        $("#btnFirst").fadeTo(0,0);
        $("#btnPrevious").fadeTo(0,0);
        $("#btnNext").fadeTo(0,0);
        $("#btnLast").fadeTo(0,0);
	}
	else if(firstVisibleCell<=0){
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0);
		$("#btnFirst").fadeTo(0,0);
    	$("#btnPrevious").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
    	$("#btnFirst").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=0;
	}
	else if(firstVisibleCell>=Math.max(outputMsgs.length-1,0)){
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0);
    	$("#btnNext").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		$("#btnLast").fadeTo(0,0);
    	$("#btnLast").css({
    		"background-color" : "#ffffff",
    		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
    	});
		firstVisibleCell=Math.max(outputMsgs.length-1,0);
	}
	else{
		$("#btnFirst").fadeTo(0,0.5);
		$("#btnPrevious").fadeTo(0,0.5);
		$("#btnNext").fadeTo(0,0.5);
		$("#btnLast").fadeTo(0,0.5);
	}
}

function showSimulationValues(){
	if(!showVarValues) return;
	
	//Αρχική τιμή του sum
	if(simulationIndex==parseInt(init1.substr(3,2))){
		$("#sumInitVal").html(" s="+sumSim+" ");
		$("#sumInitVal").show(animationRate);
	}
	else{
		$("#sumInitVal").html("");
		$("#sumInitVal").hide(animationRate);
	}
	
	//Αρχική τιμή του προσθετικού όρου
	if(simulationIndex==parseInt(init2.substr(3,2))){
		$("#adderInitVal").html(" σ="+adderSim+" ");
		$("#adderInitVal").show(animationRate);
	}
	else{
		$("#adderInitVal").html("");
		$("#adderInitVal").hide(animationRate);
	}
	
    //όρια Δομής Επανάληψης ΓΙΑ
    if(simulationIndex>=parseInt(LoopStart.substr(3,2)) && simulationIndex<=parseInt(LoopEnd.substr(3,2))){
        $("#fromToVal").html(" ΑΠΟ "+fromSim+" ΜΕΧΡΙ "+toSim+" ");
        $("#fromToVal").show(animationRate);
    }
    else{
        $("#fromToVal").html("");
        $("#fromToVal").hide(animationRate);
    }

	//Τρέχουσα τιμή αθροίσματος
	if(firstRepetitionComplete || simulationIndex>=parseInt(updateSum.substr(3,2)) && simulationIndex<=parseInt(LoopEnd.substr(3,2))){
		$("#sumVal").html(" s="+sumSim+" ");
		$("#sumVal").show(animationRate);
	}
	else{
		$("#sumVal").html("");
		$("#sumVal").hide(animationRate);
	}
	
    //Νέα τιμή προσθεταίου
    if(firstRepetitionComplete || simulationIndex>=parseInt(updateAdder.substr(3,2)) && simulationIndex<=parseInt(LoopEnd.substr(3,2))){
        $("#adderVal").html(" σ="+adderSim+" ");
        $("#adderVal").show(animationRate);
    }
    else{
        $("#adderVal").html("");
        $("#adderVal").hide(animationRate);
    }

    //Νέα τιμή προσθεταίου
    if(simulationIndex>=parseInt(LoopStart.substr(3,2)) && simulationIndex<=parseInt(LoopEnd.substr(3,2))){
        $("#iVal").html(" i="+iSim+" ");
        $("#iVal").show(animationRate);
    }
    else{
        $("#iVal").html("");
        $("#iVal").hide(animationRate);
    }
    
	//Εμφάνιση υπολογισμών μετατροπής
    if(simulationIndex==parseInt(convertSum.substr(3,2))){
        $("#quotientVal").html(" s="+(sumSim).formatNumber(3, ',', '.')+" ");
        $("#quotientVal").show(animationRate);
    }
    else{
        $("#quotientVal").html("");
        $("#quotientVal").hide(animationRate);
    }

    //Εμφάνιση τιμής του αθροίσματος μετά τη μετατροπή
    if(simulationIndex==parseInt(outputSum.substr(3,2))){
        $("#sumToPrint").html(" s="+(sumSim).formatNumber(3, ',', '.')+" ");
        $("#sumToPrint").show(animationRate);
    }
    else{
        $("#sumToPrint").html("");
        $("#sumToPrint").hide(animationRate);
    }
}

function saveUserEntry(entryID){
    
	entryIndex=parseInt(entryID.substr("usrEntr".length,2));
	userEntries[entryIndex]=trimSpaces($("#"+entryID).html());
    solutionType=userSolution;
    countEntries();
}

function countEntries(){
    var filledEntries=0;
    for(var i=0;i<userEntries.length;i++){
        if(userEntries[i]!=null && userEntries[i]!="")filledEntries++;
    }
    if(filledEntries==noOfEntries){
        //$("#solutionControls").show(animationRate); //Τα controls είναι ήδη ορατά από εκπαιδευτική άποψη
        promptID=promptToRunCode;
    }
    else{
        promptID=promptToFillInBlanks;
    }
    showPrompt();
}

function abortSimulation(){
    simulationAborted=true;
	$("#btnStop").click();
}

function showMatches(index){
    switch(index){
    case 1:
        $("#cmd0").addClass("matched");
        break;
    case 2:
        $("#cmd1").addClass("matched");
        break;
    case 3:
        $("#cmd2").addClass("matched");
        $("#cmd5").addClass("matched");
        break;
    case 4:
        $("#cmd3").addClass("matched");
        break;
    case 5:
        $("#cmd4").addClass("matched");
        break;
    case 6:
        $("#cmd6").addClass("matched");
        break;
    case 7:
        $("#cmd7").addClass("matched");
        break;
    }    
}

function updateSimulationInfo(){
    document.getElementById("mCurrent").innerHTML=mSim;
    document.getElementById("currentHeight").innerHTML=hSim+" €";
}

Number.prototype.formatNumber=function(c, d, t){
    var n=this, 
    c=isNaN(c = Math.abs(c)) ? 2 : c, 
    d=d == undefined ? "." : d, 
    t=t == undefined ? "," : t, 
    s=n < 0 ? "-" : "", 
    i=String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))), 
    j=(j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
 };